#if 0
C     
C     rrqrGate.F
C     .F file needs to be preprocessed to generate .for equivalent
C     
#endif
C
C	rrqrGate.F: Gateway for
C
C     SUBROUTINE DGEQPX( JOB, M, N, K, A, LDA, C, LDC, JPVT, IRCOND,
C     $                   ORCOND, RANK, SVLUES, WORK, LWORK, INFO )
C
C
C     Arguments
C     =========
C
C     JOB     (input) INTEGER
C     M       (input) INTEGER
C     N       (input) INTEGER
C     K       (input) INTEGER
C     A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
C     LDA     (input) INTEGER
C     C       (input/output) DOUBLE PRECISION array, dimension
C     LDC     (input) INTEGER
C     JPVT    (output) INTEGER array, dimension (N)
C     IRCOND  (input) DOUBLE PRECISION
C     ORCOND  (output) DOUBLE PRECISION
C     RANK    (output) INTEGER
C     SVLUES  (output) DOUBLE PRECISION array, dimension (4)
C     WORK    (workspace) DOUBLE PRECISION array, dimension (LWORK)
C     LWORK   (input) INTEGER
C     INFO    (output) INTEGER
#include "fintrf.h"

      subroutine mexFunction(nlhs, plhs, nrhs, prhs)
	mwPointer plhs(*), prhs(*)
	integer nlhs, nrhs

C     Datentraeger
      mwsize JOB, M, N, K, LDA, LDC, LWORK, RANK, INFO, MN
      integer MC, NC, mA, nA, i, j, RW
      integer, allocatable :: JPVT(:)

      real*8 IRCOND, ORCONDr, SVLUESr(4), helper
      complex*16 ORCONDc, SVLUESc(4)

      real*8, allocatable :: JPVTr(:)

      real*8, allocatable :: Ar(:,:), Cr(:,:), WORKr(:)
      complex*16, allocatable :: Ac(:,:), Cc(:,:), WORKc(:)

      real*8, allocatable :: RWORK(:)

      integer ic

C	declaration of matlab mex API functions
	mwsize mxGetM, mxGetN
	mwPointer mxCreateDoubleMatrix, mxGetPr, mxGetPi
C	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

C     1st case: [R,p,r]=rrqr(A,tol)
      if(nlhs .eq. 3) then

       if(nrhs .ge. 3) then
        call mexErrMsgTxt('One or two input arguments required.')
       elseif(nrhs .eq. 2) then
        call mxCopyPtrToReal8(mxGetPr(prhs(2)),IRCOND, 1)
         if(IRCOND .lt. 0) then
          call mexErrMsgTxt('tol must be greater then zero.')
         endif
       else
            IRCOND = 0 !maps to machine precision internally
       endif

            JOB = 1
            M = mxGetM(prhs(1))
            N = mxGetN(prhs(1))
            K = 0

            LDA = M
            LDC = 1
            MN = min( M, N )
            LWORK = 2*MN+3*N
            allocate (JPVT(N))
            allocate (JPVTr(N))

            ic = mxIsComplex(prhs(1))
            if (ic .eq. 1) then

            allocate (Ac(LDA,N))
            allocate (Cc(LDA,N))
            allocate (WORKc(LWORK))

            RW = 2*N
            allocate (RWORK(RW))

            call mxCopyPtrToComplex16(mxGetPr(prhs(1)),
     &                                mxGetPi(prhs(1)),Ac, LDA*N)

            call ZGEQPX( JOB,M,N,K,Ac,LDA,Cc,LDC,JPVT,IRCOND,
     &                   ORCONDr,RANK,SVLUESr,WORKc,LWORK,RWORK,INFO )

            plhs(1) = mxCreateDoubleMatrix(LDA, N, 1)
            call mxCopyComplex16ToPtr(Ac, mxGetPr(plhs(1)),
     &                                mxGetPi(plhs(1)), LDA*N)

            plhs(2) = mxCreateDoubleMatrix(N, 1, 0)
            do i=1,N,1
                  JPVTr(i)=real(JPVT(i))
            enddo
            call mxCopyReal8ToPtr(JPVTr, mxGetPr(plhs(2)) , N)

            plhs(3) = mxCreateDoubleMatrix(1, 1, 0)
            helper = real(RANK)
            call mxCopyReal8ToPtr(helper, mxGetPr(plhs(3)), 1)

            deallocate(Ac, Cc, WORKc,RWORK)

            else

            allocate (Ar(LDA,N))
            allocate (Cr(LDA,N))
            allocate (WORKr(LWORK))

            call mxCopyPtrToReal8(mxGetPr(prhs(1)), Ar, LDA*N)

            call DGEQPX( JOB, M, N, K, Ar, LDA, Cr, LDC, JPVT, IRCOND,
     &                  ORCONDr, RANK, SVLUESr, WORKr, LWORK, INFO )

            plhs(1) = mxCreateDoubleMatrix(LDA, N, 0)
            call mxCopyReal8ToPtr(Ar, mxGetPr(plhs(1)) , LDA*N)

            plhs(2) = mxCreateDoubleMatrix(N, 1, 0)
            do i=1,N,1
                  JPVTr(i)=real(JPVT(i))
            enddo
            call mxCopyReal8ToPtr(JPVTr, mxGetPr(plhs(2)) , N)

            plhs(3) = mxCreateDoubleMatrix(1, 1, 0)
            helper = real(RANK)
            call mxCopyReal8ToPtr(helper, mxGetPr(plhs(3)), 1)

            deallocate(Ar, Cr, WORKr)

            endif
            deallocate(JPVT, JPVTr)


C     2nd case: [Q,R,p,r]=rrqr(A,C,tol)
      elseif(nlhs .eq. 4) then

       if(nrhs .ge. 4 .or. nrhs .le. 1) then
        call mexErrMsgTxt('Two or three input arguments required.')
       elseif(nrhs .eq. 3) then
        call mxCopyPtrToReal8(mxGetPr(prhs(3)), IRCOND, 1)
         if(IRCOND .lt. 0) then
          call mexErrMsgTxt('tol must be greater then zero.')
         endif
       else
            IRCOND = 0 !maps to machine precision internally
       endif

            JOB = 3
            M = mxGetM(prhs(1))
            N = mxGetN(prhs(1))

            MC = mxGetM(prhs(2))
            NC = mxGetN(prhs(2))

            K = MC
            LDA = M
            LDC = K
            MN = min( M, N )
            LWORK = 2*MN+2*N+max(K,N)

            allocate (JPVT(N))
            allocate (JPVTr(N))

            ic = mxIsComplex(prhs(1))
            if (ic .eq. 1) then

            allocate (Ac(LDA,N))
            allocate (Cc(MC,NC))
            allocate (WORKc(LWORK))
           
            RW = 2*N
            allocate (RWORK(RW))

            call mxCopyPtrToComplex16(mxGetPr(prhs(1)),
     &                                mxGetPi(prhs(1)),Ac, LDA*N)
            call mxCopyPtrToComplex16(mxGetPr(prhs(2)),
     &                                mxGetPi(prhs(2)),Cc, MC*NC)

            call ZGEQPX(JOB, M, N, K, Ac, LDA, Cc, LDC, JPVT, IRCOND,
     &                  ORCONDr,RANK,SVLUESr,WORKc,LWORK,RWORK,INFO)

            plhs(1) = mxCreateDoubleMatrix(MC, NC, 1)
            call mxCopyComplex16ToPtr(Cc, mxGetPr(plhs(1)),
     &                                mxGetPi(plhs(1)),MC*NC)

            plhs(2) = mxCreateDoubleMatrix(LDA, N, 1)
            call mxCopyComplex16ToPtr(Ac, mxGetPr(plhs(2)),
     &                                mxGetPi(plhs(2)),LDA*N)

            plhs(3) = mxCreateDoubleMatrix(N, 1, 0)
            do i=1,N,1
                  JPVTr(i)=real(JPVT(i))
            enddo
            call mxCopyReal8ToPtr(JPVTr, mxGetPr(plhs(3)), N)

            plhs(4) = mxCreateDoubleMatrix(1, 1, 0)
            helper = real(RANK)
            call mxCopyReal8ToPtr(helper, mxGetPr(plhs(4)) , 1)

            deallocate(Ac, Cc, WORKc,RWORK)

            else

            allocate (Ar(LDA,N))
            allocate (Cr(MC,NC))
            allocate (WORKr(LWORK))

            call mxCopyPtrToReal8(mxGetPr(prhs(1)), Ar, LDA*N)
            call mxCopyPtrToReal8(mxGetPr(prhs(2)), Cr, MC*NC)

            call DGEQPX( JOB, M, N, K, Ar, LDA, Cr, LDC, JPVT, IRCOND,
     &                  ORCONDr, RANK, SVLUESr, WORKr, LWORK, INFO )

            plhs(1) = mxCreateDoubleMatrix(MC, NC, 0)
            call mxCopyReal8ToPtr(Cr, mxGetPr(plhs(1)) , MC*NC)

            plhs(2) = mxCreateDoubleMatrix(LDA, N, 0)
            call mxCopyReal8ToPtr(Ar, mxGetPr(plhs(2)) , LDA*N)

            plhs(3) = mxCreateDoubleMatrix(N, 1, 0)
            do i=1,N,1
                  JPVTr(i)=real(JPVT(i))
            enddo
            call mxCopyReal8ToPtr(JPVTr, mxGetPr(plhs(3)), N)

            plhs(4) = mxCreateDoubleMatrix(1, 1, 0)
            helper = real(RANK)
            call mxCopyReal8ToPtr(helper, mxGetPr(plhs(4)) , 1)

            deallocate(Ar, Cr, WORKr)

            endif

            deallocate(JPVT, JPVTr)


      else
           call mexErrMsgTxt('Three or four output arguments required.')
      endif

      return
      end
